﻿@using geneeditor.Entities;
@using geneeditor.Controllers;


<style>
    .Main{
        display: none;
    }
    .Found{
        display: none;
    }
</style>

@{char[] nucs = { 'A', 'C', 'G', 'T' }; }

<link href="https://fonts.googleapis.com/css?family=Comfortaa|Merriweather:300i&display=swap" rel="stylesheet">
<div class="container Main">

    <div class="col- Main_empty"></div>

    <div class="col- Main_text d-flex justify-content-center">
        <a href="/Home/Index" class="help">
            <h1>
                <span class="Main_text_1">C</span><span class="Main_text_2">R</span><span
                    class="Main_text_3">I</span><span class="Main_text_4">S</span><span
                    class="Main_text_5">P</span><span class="Main_text_6">R</span><span class="Main_text_7"> /
                </span><span class="Main_text_8">C</span><span class="Main_text_9">a</span><span
                    class="Main_text_10">s</span>
            </h1>
        </a>
    </div>


    <div class="w-100"></div>

    <div class="col- Main_form d-flex justify-content-center">
        <form action="/Home/Contact" class="col d-flex justify-content-center">
            <input class="Main_form_input_contact clik" name="searchString" type="search"
                placeholder="Ведите данные: Pam, Cas, Bacterium, specer">
            <input class="Main_form_button_contact" type="submit" value="Поиск в Базе">
        </form>
    </div>

</div>


<div class="container Found">
    <h4 class="ViewBag">Для запроса "@ViewBag.CasInp" по типу "@ViewBag.Type" найдены:</h4>
    <br>
    <br>
    @{if (ViewBag.CasInp != null && ViewBag.Type == "Cas" || ViewBag.Type =="Тип" || ViewBag.Type == null || ViewBag.Type == "") {
    <div class="row">
        @{
            List<Protein> proteins = AppManager.GetInstance().db.Proteins.ToList().Where(s =>
                s.Signature.Contains(((string)(ViewBag.CasInp)).Trim().ToLower())).ToList();

            foreach (Protein pr in proteins)
            {
                List<PAM> pams = AppManager.GetInstance().db.PAMs
                    .Where(s => s.ProteinId == pr.Id)
                    .ToList();

                <div class="col-12 Card ca align-self-start">

                    <div class="card">

                        <div class="col- cas-forMobilet row">
                            <h4 class="col card_cas card_cas2 mr-auto">@pr.Signature</h4>
                            <p class="col- cas-forMobile">&#9661;</p>
                        </div>

                        <div class="col- cas-forMobile__open">
                            <h4 class="card_cas_props">Класс: @pr.proteinClass&nbsp;&nbsp;&nbsp;&nbsp;Тип:
                                @pr.proteinType
                            </h4>
                            <hr>
                            <h5>Консенсусная Pam последовательность</h5>

                            <div class="col row Pam_Diagram d-flex justify-content-center">
                                @{
                                for (int j = 0; j < 20; j++) { <div class="col row d-flex flex-column">
                                    @{
                                    for (int i = 0; i < nucs.Length; i++) { float h=MathF.Round((100f * pams.Count(p=>
                                        p.Code[j] == nucs[i])) / pams.Count, 0, MidpointRounding.ToEven);

                                        if (h != 0) {
                                        <script>
                                            var $arr = ['#4285f4', '#ea4335', '#fbbc05', '#34a853'];
                                            $('.Pam_Diagram:last').children().eq(@j).append('<div class="pm_text d-flex align-self-center" title="Статистическая вероятность нуклеотида @nucs[i] = @h%" style="height: @h%; background-color:' + $arr[@i]+ '"><p style="text-align:center; width:100%">@nucs[i]</p></div>');
                                        </script>
                                        }
                                        }
                                        }
                            </div>
                            }
                            }
                        </div>
                        <h5>PAM последовательности<span class="Text">&nbsp;для этого белка</span></h5>
                        <div class="col Pam_Diagrams ">
                                @{var t = 0;
                                    foreach (PAM pm in pams) {
                                    <div class="col row">
                                        @{ for (int j = 0; j < 20; j++) {
                                        <script>
                                            $('.Pam_Diagrams:last').children().eq(@t).append('<div class="col d-flex align-self-center"><p class="Pm_text" style="text-align:center; width:100%">@pm.Code.Substring(j,1)</p></div>');
                                        </script>
                                        }}
                                    </div>
                                    
                           t++; }
                            }
                        </div>


                        
                        <hr>
                        <div class="d-flex justify-content-center card_bac">
                            <h4 class="mr-auto h">Бактерии <span class="card_bac_show"> Показать/Скрыть</span></h4>
                            <p>&#9661;</p>
                        </div>
                        <div class="card_bac_panel">
                            <table>
                                @{ bool empty = true; }
                                @foreach (Bac bac in AppManager.GetInstance().db.Bacs.ToList()) {

                                List<Spacer> spacers = AppManager.GetInstance().db.Spacers
                                    .Where(s => s.BacId == bac.Id)
                                    .ToList();

                                    if (spacers.Count != 0)
                                    {
                                    empty = false;
                                    <tr>
                                        <th class="Bac">@bac.Code</th>
                                    </tr>

                                    foreach (Spacer s in spacers)
                                    {

                                    <tr>
                                        <th>@s.Code</th>
                                    </tr>
                                    }

                                    <tr>
                                        <th>&nbsp; </th>
                                    </tr>
                                    }
                                    }
                                    @{if (empty){ <tr>
                                        <th>
                                            <h4 class="mr-auto">Бактерии с подходящими спейсерами не нашлись</h4>
                                        </th>
                                    </tr>} }

                            </table>

                        </div>
                    </div>

                </div>
    </div>
    }

    }

    @{if (proteins.Count == 1){
    <script>
        $('.ca').attr('class', 'col-12 Card ca align-self-start')
    </script>
    }
    else{
    <script>
        $('.ca').attr('class', 'col- col-sm-12 col-md-12 col-lg-6 col-xl-4 Card ca align-self-start')
    </script>
    }
    }

</div>
}}
@{if (ViewBag.CasInp != null &&  ViewBag.Type == "Pam"){
<div class="row">
    @{
    List<PAM> pAMs = AppManager.GetInstance().db.PAMs.ToList().Where(s =>
        s.Code.Contains(((string)(ViewBag.CasInp)).Trim())).ToList();

        @foreach (PAM pm in pAMs)
        {

        <div class="Card ca col- col-sm-12 col-md-12 col-lg-6 col-xl-4 Card ca align-self-start">

            <div class="card">

                <div class="row">
                    <div class="col cas-forMobilet row">
                        <h4 class="col- card_cas mr-auto">@pm.Code</h4>
                    </div>


                    <p class="col- cas-forMobile">&#9661;</p>
                </div>

                <div class="col- cas-forMobile__open">
                    <hr>
                    <h5>Белки с комплементарной PAM последовательностью</h5>
                    <div class="divtable">
                        <table>
                            @{ bool empty = true; }
                            @foreach (Protein pr in AppManager.GetInstance().db.Proteins.ToList())
                            {

                            List<PAM> pAMs1 = AppManager.GetInstance().db.PAMs
                                .Where(s => s.ProteinId == pr.Id)
                                .Where(s => s.Code.Contains(((string)(pm.Code)).Trim())).ToList();


                                List<Spacer> spacers = AppManager.GetInstance().db.Spacers
                                    .ToList();

                                    if (pAMs1.Count != 0)
                                    {
                                    empty = false;
                                    <tr>
                                        <th class="Bac">@pr.Signature</th>
                                    </tr>

                                    <tr>

                                        @foreach (Spacer sp1 in spacers)
                                        {


                                        <th>@sp1.Code</th>

                                        }

                                        @foreach (PAM pm1 in pAMs1)
                                        {


                                        <th>@pm1.Code</th>

                                        }
                                    </tr>

                                    <tr>
                                        <th>&nbsp; </th>
                                    </tr>
                                    }
                                    }
                                    @{if (empty)
                                    {
                                    <tr>
                                        <th>
                                            <h4 class="mr-auto">Бактерии с подходящими спейсерами не нашлись</h4>
                                        </th>
                                    </tr>} }
                        </table>
                    </div>
                    <hr>

                </div>

            </div>
        </div>
        }

        }
        @{if (pAMs.Count == 1){
        <script>
            $('.ca').attr('class', 'col-12 Card ca align-self-start')
        </script>
        }
        else{
        <script>
            $('.ca').attr('class', 'col- col-sm-12 col-md-12 col-lg-6 col-xl-4 Card ca align-self-start')
        </script>
        }
        }

</div>
}}

</div>









<script src="~/js/site.js"></script>